<template>
	<view class="container">
		<view class="carousel-section">
			<!-- 背景色区域 -->
			<view class="bg">
				<image src="../../static/index/index13.png" mode=""></image>
			</view>
			<!-- 标题栏和状态栏占位符 -->
			<view class="titleNview-placing"></view>
			<!-- 搜素栏 -->
			<view class="search flex">
				<!-- <image src="../../static/index/index09.png" class="address"></image> -->
				<!-- <view class="shop-name clamp" @click.stop="canChange == 0?nav('/pages/shoping/list'):''">{{ storeInfo.name }}</view> -->
				<!-- <view class="shop-name clamp">椒江区</view> -->
				<!-- <image class="shop-jt" src="../../static/index/index07.png" mode=""></image> -->
				<view class="input-box flex" @click.stop="clickSearch">
					<view class=" input-content flex">
						<view class="iconfont iconsearch"></view>
						<view class="input"><input type="text" disabled value="输入关键字搜索" /></view>
					</view>
				</view>
			</view>
			<swiper class="carousel" autoplay="true" duration="400" interval="5000" :indicator-dots="true"
				indicator-active-color="#FFFFFF">
				<!-- <swiper class="carousel" autoplay="true" duration="400" interval="5000"> -->
				<swiper-item v-for="(item, index) in carouselList" :key="index" class="carousel-item">
					<image :src="item.pic" mode="aspectFill" @click="bannerNavToUrl(item)"></image>
				</swiper-item>
			</swiper>
		</view>
		<view class="navbar">
			<view class="navbar-box flex">
				<view class="navbar-item" @click="navTo('/pages/category/category')">
					<image class="nitem-image" src="../../static/index/index03.png" mode=""></image>
					<view class="nitem-font">全部商品</view>
				</view>
				<view class="navbar-item" @click="navTo('')">
					<image class="nitem-image" src="../../static/index/index04.png" mode=""></image>
					<view class="nitem-font">公司介绍</view>
				</view>
				<view class="navbar-item" @click="$refs.popupkf.open()">
					<image class="nitem-image" src="../../static/index/index16.png" mode=""></image>
					<view class="nitem-font">联系客服</view>
				</view>

				<view class="navbar-item" @click="navTo('/pages/user/shareQrCode')">
					<image class="nitem-image" src="../../static/index/index02.png" mode=""></image>
					<view class="nitem-font">邀请有礼</view>
				</view>
			</view>
		</view>
		<view class="product-box" v-if="bastList.length != 0">
			<view class="cnxh">
				<view class="hx">

				</view>
				<view class="">
					猜你喜欢
				</view>
				<view class="hx">

				</view>
			</view>
			<view class="hotgoods">
				<view class="hotgoods-item" v-for="item in bastList" :key="item.id" @click="navToDetailPage(item)">
					<view class="image-wrapper">
						<image class="image-bg" src="../../static/img/libao-bg.png" mode=""></image>
						<image class="image" :src="item.image" mode="scaleToFill"></image>
					</view>
					<view class="title clamp2">{{ item.store_name }}</view>
					<view class="hot-price">
						<view class="hotPrice-box">会员价</view>
						<view class="price">
							<text class="font-size-sm">￥</text>
							{{ item.price * 1 }}
						</view>
						<view class="yuanPrice">{{ item.ot_price }}</view>
					</view>
				</view>
			</view>
		</view>
		<!-- 客服 -->
		<uni-popup ref="popupkf" type="center">
			<view class="popup-box">
				<view class="img">
					<image src="../../static/img/img009.png" mode=""></image>
				</view>
				<view class="mian">
					<view class="delivery">
						<view class="title">已经为您定制专属客服</view>
						<image src="../../static/img/img010.png" mode=""></image>
					</view>
					<view class="nocancel">客服VX:{{ text }}</view>
					<view class="comfirm-box">
						<view class="cancel" @click="kfClose()">取消</view>
						<view class="comfirm" @click="comfirm(text)">复制微信</view>
					</view>
				</view>
			</view>
		</uni-popup>
	</view>
</template>

<script>
	import {
		lookSubpoints,
		lookOneself
	} from '../../api/user.js';
	import seckill from '../../components/seckill/seckill.vue';
	import {
		loadIndexs
	} from '@/api/index.js';
	import {
		getUserInfo,
		spread
	} from '@/api/user.js';
	import {
		setCoupons
	} from '@/api/functionalUnit.js';
	import {
		getBargainList,
		getProducts
	} from '@/api/product.js';
	import {
		interceptor
	} from '@/utils/loginUtils';
	import {
		mapState,
		mapMutations
	} from 'vuex';
	import {
		tabbar
	} from '@/utils/tabbar.js';
	// #ifdef H5
	import {
		weixindata,
		shareLoad
	} from '@/utils/wxAuthorized';
	// #endif
	import uniCopy from '@/js_sdk/xb-copy/uni-copy.js';
	export default {
		components: {
			seckill
		},
		data() {
			return {
				text: '',
				tabbar: tabbar,
				current: 0,
				shareShow: false, //分享海报
				pageProportion: 0, //保存页面基于750宽度的比例
				swiperHeight: 0,
				checkid: 0,
				titleNViewBackground: '',
				longitude: 0, //经度
				latitude: 0, //纬度
				swiperCurrent: 0,
				swiperLength: 0,
				carouselList: [], //轮播列表
				bastList: [], //会员礼包
				shoplist: [], //商店列表
				page: 1,
				limit: 5,
				bargainlist: []
			};
		},
		computed: {
			...mapState(['loginInterceptor', 'baseURL']),
			...mapState('user', ['hasLogin', 'userInfo'])
		},
		onLoad: function(option) {
			this.getaddress();
			// #ifdef MP
			if (option.scene) {
				// 存储小程序邀请人
				uni.setStorage({
					key: 'spread_code',
					data: option.scene
				});
			}
			// #endif
			// #ifdef H5
			this.IndexShare();
			//#endif
		},
		onShow: function() {
			// 判断是否强制登录
			// if (!this.hasLogin) {
			// 	// 登录拦截
			// 	interceptor();
			// }
			this.loadData();
			this.getProduct()
			// this.getBargainList();
		},
		//下拉刷新
		onPullDownRefresh() {
			this.loadData();
		},
		// #ifndef MP
		// 监听导航栏输入框点击事件
		onNavigationBarSearchInputClicked(e) {
			//跳转到搜索页面
			this.clickSearch();
		},
		//点击导航栏 buttons 时触发
		onNavigationBarButtonTap(e) {
			const index = e.index;
			if (index === 0) {
				this.$api.msg('点击了扫描');
			} else if (index === 1) {
				// #ifdef APP-PLUS
				const pages = getCurrentPages();
				const page = pages[pages.length - 1];
				const currentWebview = page.$getAppWebview();
				currentWebview.hideTitleNViewButtonRedDot({
					index
				});
				// #endif
				uni.navigateTo({
					url: '/pages/user/notice'
				});
			}
		},
		// #endif
		methods: {
			...mapMutations(['setLat', 'setLon']),
			kfClose() {
				this.$refs.popupkf.close()
			},
			// 复制
			comfirm(text) {
				console.log(text);
				const result = uniCopy(text);
				if (result === false) {
					uni.showToast({
						title: '不支持'
					});
				} else {
					uni.showToast({
						title: '复制成功',
						icon: 'none'
					});
				}
				this.$refs.popupkp.close();
			},
			// #ifdef H5
			IndexShare() {
				let obj = this;
				let pages = getCurrentPages();
				// 获取当前页面
				let page = pages[pages.length - 1];
				let path = '#/' + page.route + '?';
				// 保存传值
				for (let i in page.options) {
					path += i + '=' + page.options[i] + '&';
				}
				console.log(obj.Path);
				// 保存邀请人
				path += 'spread=' + this.userInfo.uid;
				let data = {
					link: this.baseURL + '/index/' + path,
					title: this.userInfo.nickname + '邀请您进入响亮商城',
					desc: '欢迎加入响亮商城',
					imgUrl: 'https://xl.liuniu946.com/index/static/img/logo.jpg'
				};
				console.log(data, '分享数据');
				shareLoad(data);
			},
			// #endif
			getaddress() {
				console.log('dizhi+++++++++++');
				let obj = this;
				// uni.getLocation({
				// 	type: 'gcj02',
				// 	success: res => {
				// 		console.log(res, 123456);
				// 		obj.setLat(res.latitude);
				// 		obj.setLon(res.longitude);
				// 	},
				// 	fail: err => {
				// 		console.log(err, 'shi+++++++++++++++');
				// 		openMap().then(e => {
				// 			this.getaddress();
				// 		});
				// 	}
				// });
				weixindata().then(wxOjb => {
					console.log(wxOjb, '获取微信');
					wxOjb.getLocation({
						type: 'gcj02',
						success: res => {
							console.log(res, 123456);
							obj.setLat(res.latitude);
							obj.setLon(res.longitude);
						},
						fail: err => {
							console.log(err, 'shi+++++++++++++++');
							openMap().then(e => {
								this.getaddress();
							});
						}
					});
				});
			},
			//砍价商品推荐详情页
			navToDetailPages(item) {
				let id = item.product_id;
				//let type = 2;

				uni.navigateTo({
					url: '/pages/product/product?id=' + id
				});
			},
			navTo(url) {
				if (url == '') {
					this.$api.msg('暂未开通，敬请期待');
				} else {
					uni.navigateTo({
						url,
						fail() {
							uni.switchTab({
								url
							})
						}
					});
				}
			},
			openSubscribe: function(e) {
				let page = e;
				// #ifndef MP
				uni.navigateTo({
					url: page
				});
				// #endif
				// #ifdef MP
				uni.showLoading({
					title: '正在加载'
				});
				openBargainSubscribe()
					.then(res => {
						uni.hideLoading();
						uni.navigateTo({
							url: page
						});
					})
					.catch(err => {
						uni.hideLoading();
					});
				// #endif
			},
			getBargainList() {
				let that = this;

				getBargainList({
						page: that.page,
						limit: that.limit
					})
					.then(function(res) {
						that.$set(that, 'bargainlist', res.data.slice(0, 2));
						console.log(that.bargainlist)
					})
					.catch(res => {
						console.log(res, 'getBargainList');
					});
			},
			Mask() {
				this.MaskShow = false;
				this.shareShow = true;
				uni.setStorage({
					key: 'FirstEntry',
					data: true,
					success: function() {
						console.log(uni.getStorageSync('FirstEntry'), 'Mask');
					}
				});
			},
			Toshare() {
				if (this.userInfo == '') {
					getUserInfo({})
						.then(({
							data
						}) => {
							this.setUserInfo(data);
							this.userInfo = data;
						})
						.catch(e => {});
				} else {
					this.shareShow = false;
					uni.navigateTo({
						url: '/pages/user/shareQrCode?spread=' + this.userInfo.uid
					});
				}
			},
			Tocancel() {
				this.shareShow = false;
			},
			// 监听切换事件
			listChange(e) {
				this.checkid = e.detail.current;
			},
			// 點擊搜索框
			clickSearch() {
				uni.navigateTo({
					url: '/pages/product/search'
				});
			},
			// 点击触发领取优惠券
			setCoupons(item) {
				// 判断是否已经领取了优惠券
				let obj = this;
				uni.showModal({
					title: '领取提示',
					content: '是否领取优惠券',
					success(e) {
						if (e.confirm) {
							setCoupons({
								couponId: item.id
							}).then(e => {
								item.is_use = true;
								uni.showToast({
									title: '领取成功',
									type: 'top',
									duration: 2000
								});
							});
						}
					}
				});
			},
			//商品种类切换
			change(item) {
				let id = item;
				this.checkid = id;
				if (this.checkid == 1) {
					// console.log(1);
					this.detail = this.selected_detail;
				} else if (this.checkid == 2) {
					// console.log(2);
					this.detail = this.new_product;
				} else {
					this.detail = this.cheap_good;
				}
			},
			// 监听图片加载完成
			onImageError(key, index) {
				this[key][index].image = '/static/error/errorImage.jpg';
			},
			// 请求载入数据
			async loadData() {
				loadIndexs({})
					.then(({
						data
					}) => {
						let goods = data.info;
						this.carouselList = data.banner;
						console.log(this.carouselList, 'this.carouselList++++++++')
						this.swiperLength = this.carouselList.length;
						// this.bastList = data.giftInfo; //会员礼包
						uni.stopPullDownRefresh();
					})
					.catch(e => {
						uni.stopPullDownRefresh();
					});
			},
			//轮播图切换修改背景色
			swiperChange(e) {
				const index = e.detail.current;
				this.swiperCurrent = index;
				this.titleNViewBackground = this.carouselList[index].background;
			},
			//详情页
			navToDetailPage(item) {
				let id = item.id;
				uni.navigateTo({
					url: '/pages/product/product?id=' + id + '&isVip=1'
				});
			},

			// 轮播图跳转
			bannerNavToUrl(item) {
				// #ifdef H5
				console.log(item.wap_url.indexOf('http'), 'banner');
				if (item.wap_url.indexOf('http') >= 0) {
					window.location.href = item.wap_url;
				}
				// #endif
				//测试数据没有写id，用title代替
				uni.navigateTo({
					url: item.wap_url
				});
			},
			getProduct() {
				getProducts().then(res => {
					console.log(res.data)
					this.bastList = res.data
				})
			}
		}
	};
</script>

<style lang="scss">
	.carousel-section {
		position: relative;
		padding-top: 10px;

		.bg {
			position: absolute;
			top: 0;
			left: 0;
			width: 750rpx;
			height: 378rpx;

			image {
				width: 100%;
				height: 100%;
			}
		}

		.titleNview-placing {
			height: var(--status-bar-height);
			box-sizing: content-box;
		}

		.search {
			justify-content: flex-start;
			padding: 10rpx 32rpx 20rpx;
			align-items: center;

			.address {
				width: 32rpx;
				height: 38rpx;
			}

			.shop-name {
				height: 38rpx;
				position: relative;
				top: -4rpx;
				z-index: 100;
				font-size: 30rpx;
				font-family: PingFang SC;
				font-weight: 500;
				color: #ffffff;
				padding-left: 10rpx;
			}

			.shop-jt {
				margin-left: 8rpx;
				width: 16rpx;
				height: 10rpx;
			}

			.input-box {
				margin-left: 10rpx;
				position: relative;
				z-index: 99;
				width: 700rpx;
				height: 60rpx;
				background: rgba(255, 255, 255, 0.4);
				border-radius: 30rpx;

				.input-content {
					position: relative;
					z-index: 11;
					border-radius: 99rpx;
					flex-grow: 1;
					padding: 5rpx 30rpx;
					background: rgba(255, 255, 255, 0.4);

					.iconsearch {
						font-size: 50rpx;
						color: #ffffff;
					}

					.input {
						margin-left: 19rpx;
						flex-grow: 1;
						color: #ffffff;

						input {
							font-size: 28rpx;

							color: #ffffff;
						}
					}
				}

				.input-button {
					padding-left: 20rpx;
					font-size: $font-base;
					height: 100%;
				}
			}
		}
	}

	.carousel {
		position: relative;
		z-index: 3;
		width: 100%;
		height: 360rpx;

		.carousel-item {
			width: 100%;
			height: 100%;
			padding: 0 28rpx;
			overflow: hidden;
		}

		image {
			width: 100%;
			height: 100%;
			border-radius: $border-radius-sm;
		}
	}

	.navbar {
		position: relative;
		z-index: 2;
		margin-top: -200rpx;
		width: 750rpx;
		height: 462rpx;
		background: #ffffff;
		border-radius: 40rpx;

		.navbar-box {
			padding-top: 250rpx;

			.navbar-item {
				display: flex;
				flex-direction: column;
				align-items: center;
				width: 25%;

				.nitem-image {
					width: 98rpx;
					height: 98rpx;
				}

				.nitem-font {
					margin-top: 22rpx;
					font-size: 26rpx;
					font-family: PingFang SC;
					font-weight: 500;
					color: #000000;
				}
			}
		}
	}

	.product-box {
		margin-top: 20rpx;
		background: #ffffff;
		padding: 26rpx 30rpx 20rpx;

		.product-title {
			display: flex;
			align-items: center;

			.pt-image {
				width: 36rpx;
				height: 36rpx;
			}

			.pt-title {
				margin-left: 8rpx;
				font-size: 32rpx;
				font-family: PingFang SC;
				font-weight: bold;
				color: #333333;
			}

			.pt-tip {
				margin-left: 16rpx;
				font-size: 20rpx;
				font-family: PingFang SC;
				font-weight: bold;
				color: #95a0b1;
			}
		}

		.hotgoods {
			margin-top: 38rpx;
			width: 100%;
			display: flex;
			flex-wrap: wrap;
			padding: 0 0 30rpx;

			.hotgoods-item {
				width: 48%;
				background-color: #ffffff;
				border-radius: 12rpx;

				&:nth-child(2n + 1) {
					margin-right: 24rpx;
				}

				.image-wrapper {
					width: 100%;
					height: 330rpx;
					border-radius: 3px;
					overflow: hidden;
					position: relative;

					.image-bg {
						position: absolute;
						top: 0;
						left: 0;
						right: 0;
						bottom: 0;
						width: 100%;
						height: 100%;
						opacity: 1;
						border-radius: 12rpx 12rpx 0 0;
						z-index: 2;
					}

					.image {
						width: 100%;
						height: 100%;
						opacity: 1;
						border-radius: 12rpx 12rpx 0 0;
					}
				}

				.title {
					margin-top: 24rpx;
					font-size: 28rpx;
					font-family: PingFang SC;
					font-weight: 500;
					color: #333333;
				}

				.hot-price {
					display: flex;
					justify-content: flex-start;
					align-items: center;
					padding: 14rpx 0 30rpx;

					.hotPrice-box {
						width: 70rpx;
						height: 28rpx;
						background: linear-gradient(90deg, #c79a4c, #f9df7f);
						border-radius: 5rpx;
						text-align: center;
						line-height: 28rpx;
						font-size: 20rpx;
						font-family: Source Han Sans CN;
						font-weight: 400;
						color: #ffffff;
					}

					.price {
						margin-left: 10rpx;
						font-size: 40rpx;
						color: #ff0000;
						font-weight: 500;
					}

					.yuanPrice {
						margin-left: 10rpx;
						font-size: 20rpx;
						font-family: PingFang SC;
						font-weight: 500;
						text-decoration: line-through;
						color: #999999;
					}

					.cart-icon {
						image {
							width: 44rpx;
							height: 44rpx;
						}
					}
				}
			}
		}
	}

	.popup-box {
		width: 522rpx;
		height: 605rpx;
		background-color: #ffffff;
		border-radius: 20rpx;
		position: relative;

		.img {
			position: relative;
			top: -56rpx;
			left: 0;
			width: 522rpx;
			height: 132rpx;
			display: flex;
			justify-content: center;

			image {
				border-radius: 20rpx 20rpx 0 0;
				width: 450rpx;
				height: 132rpx;
			}
		}

		.mian {
			margin-top: -44rpx;
			display: flex;
			flex-direction: column;
			align-items: center;
			// padding: 32rpx 32rpx;
			background-color: #ffffff;
			border-radius: 0 0 20rpx 20rpx;
			text-align: center;

			.delivery {
				font-size: 40rpx;
				color: #333333;
				display: flex;
				align-items: center;
				flex-direction: column;

				.title {}

				image {
					margin-top: 48rpx;
					width: 172rpx;
					height: 160rpx;
				}
			}

			.nocancel {
				font-size: 32rpx;
				color: #333333;
				margin-top: 14rpx;
			}

			.comfirm-box {
				margin-top: 52rpx;
				display: flex;
				// margin-bottom: 32rpx;

				// justify-content: space-around;
				.cancel {
					display: flex;
					align-items: center;
					justify-content: center;
					width: 197rpx;
					height: 74rpx;
					border: 1px solid #dcc786;
					border-radius: 38rpx;

					font-size: 32rpx;
					color: #605128;
				}

				.comfirm {
					margin-left: 32rpx;
					display: flex;
					align-items: center;
					justify-content: center;
					width: 197rpx;
					height: 74rpx;
					background: linear-gradient(-90deg, #d1ba77 0%, #f7e8ad 100%);
					border-radius: 38px;
					font-size: 32rpx;
					color: #605128;
				}
			}
		}

	}

	.cnxh {
		text-align: center;
		font-size: 30rpx;
		font-weight: 500;
		color: #363636;
		display: flex;
		justify-content: center;
		align-items: center;
		padding: 20rpx 0;

		.hx {
			width: 120rpx;
			height: 1rpx;
			background: #989898;
			margin: 0 40rpx;
		}
	}
</style>
